<?php
require __DIR__.'/conf.php'; //Configuration
require __DIR__.'/vendor/autoload.php';
use phpish\shopify;
$access_token = $_REQUEST['access_token'];
$shop = $_REQUEST['shop'];
$shopify = shopify\client($_REQUEST['shop'], SHOPIFY_APP_API_KEY, $access_token );
try
{	
	$themes = $shopify("GET /admin/api/2022-10/themes.json");
	foreach($themes as $theme) {
		if($theme['role'] == 'main') {
			$themeId = $theme['id'];
			// Add Asset JS file
			$jsData = "var dg$;
var script = document.createElement('script');
script.setAttribute('src', '//ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js');
script.addEventListener('load', function() {
  dg$ = $.noConflict(true);
  snapHnkScript(dg$);
});
document.head.appendChild(script);

function snapHnkScript($) {
	var pageURL = window.location.href;
	var user_email = '';
	var currency = $('meta[name=\"shopCurrency\"]').attr('content');
	if($('meta[name=\"customerEmail\"]').length) {
		var user_email = $('meta[name=\"customerEmail\"]').attr('content');  
	}
	var pixelCode = $('.snapPixels p').text();
	
	if(pixelCode != '') {
		var showAddtoCartPixel = '';
		var snapchatCode = \"(function(win, doc, sdk_url){if(win.snaptr) return;var tr=win.snaptr=function(){tr.handleRequest? tr.handleRequest.apply(tr, arguments):tr.queue.push(arguments);}; tr.queue = [];var s='script';var new_script_section=doc.createElement(s);new_script_section.async=!0;new_script_section.src=sdk_url;var insert_pos=doc.getElementsByTagName(s)[0];insert_pos.parentNode.insertBefore(new_script_section, insert_pos);})(window, document, 'https://sc-static.net/scevent.min.js');snaptr('init','\"+pixelCode+\"',{'user_email':'\"+user_email+\"'});\";
		
		if(pageURL.indexOf('/products/') > -1) {
			$('head').append(\"<script type='text/javascript'>\"+snapchatCode+\"snaptr('track','PAGE_VIEW');snaptr('track','VIEW_CONTENT');</script>\");
			
			// start On Add to Cart Click
			if (pageURL.indexOf('?variant=') > -1) {
				var product_url = pageURL.split('?variant=');
				product_url = product_url[0] + '.json';
			} else {
				var product_url = pageURL + '.json';
			}
			$.ajax({
				url: product_url,
				dataType: 'jsonp',
				header: {
					'Access-Control-Allow-Origin': '*'
				},
				success: function(responseData) {
					var product = responseData.product;
					$('form[action=\"/cart/add\"] [type=\"submit\"], form[action=\"/cart/add\"] [type=\"button\"]').click(function(e){
					
					    if(pageURL.indexOf('1hstl.com') > -1) {
					        e.preventDefault();
                            e.stopPropagation();
                            $('form[action=\"/cart/add\"]').submit();
					    }

						var variantid = $('[name=\"id\"]').val();
						if(variantid === undefined || variantid === null) {
							price = product.variants[0].price;
						} else {
							$.each(product.variants, function(index){
								if(product.variants[index].id == variantid){
									price = product.variants[index].price;
								}
							});
						}
						
						showAddtoCartPixel += \"snaptr('track', 'ADD_CART', {'currency': '\"+currency+\"', 'price': \"+price+\" });\";
						$('head').append(\"<script type='text/javascript'>\"+snapchatCode+\"\"+showAddtoCartPixel+\"</script>\");

					});
				}
			});
			// end On Add to Cart Click
		} else {
			// On Page View
			$('head').append(\"<script type='text/javascript'>\"+snapchatCode+\"snaptr('track','PAGE_VIEW');</script>\");
			
			// start On Add to Cart Click
			$('body').on('click', 'form[action=\"/cart/add\"] [type=\"submit\"], form[action=\"/cart/add\"] [type=\"button\"]', function(e){
				if(window.location.hostname == 'fr.thebabylonstore.com') {
					e.preventDefault();
				}
				var formEle = $(this).parent('form[action=\"/cart/add\"]');
				var variantData = formEle.find('select[name=\"id\"] option:selected').text();
				if(variantData != '') {
					var priceArr = variantData.split('-');
					price = priceArr[priceArr.length - 1];
					price = price.replace(/[^0-9\.]/g,'');
					showAddtoCartPixel += \"snaptr('track', 'ADD_CART', {'currency': '\"+currency+\"', 'price': \"+price+\" });\";
					$('head').append(\"<script type='text/javascript'>\"+snapchatCode+\"\"+showAddtoCartPixel+\"</script>\");
					if(window.location.hostname == 'fr.thebabylonstore.com') {
						setTimeout(function(){
							$('form[action=\"/cart/add\"]').submit();
						}, 1000);
					}
				}
			});
			// end On Add to Cart Click
		}
		
		// start On Checkout button click 
		$('body').on( 'click', '[name=\"checkout\"]', function(e) {
			e.preventDefault();
			window.location.href = '/checkout';
			$('head').append(\"<script type='text/javascript'>\"+snapchatCode+\"snaptr('track', 'START_CHECKOUT');</script>\");
		});
		if($('[name=\"checkout\"]').length == 0) {
			$('body').on('click', 'form[action=\"/checkout\"] [type=\"submit\"], form[action=\"/checkout\"] [type=\"button\"]', function(){
				$('head').append(\"<script type='text/javascript'>\"+snapchatCode+\"snaptr('track', 'START_CHECKOUT');</script>\");
			});
		}
		// end On Checkout button click
	}
}";

			// Add Snippet file
					
			if(is_dir('pull')) {
				if (!is_dir('pull/'.$shop)) {
					mkdir('pull/'.$shop);
					$filepath = 'pull/'.$shop;
				} else {
					$filepath = 'pull/'.$shop;
				}
				$filename = $filepath.'/snaphook.js';
				$jsfile = fopen($filename, "w");
				fwrite($jsfile, $jsData);
				fclose($jsfile);
			}
			
			$permanent_domain = APP_SERVER_URL."pull/{{shop.permanent_domain}}/snaphook.js";
			$snippet_code = '{%if shop.metafields.SnapchatPixelCode != blank %}
  <div class="snapPixels" style="display:none;">
    {%- for field in shop.metafields.SnapchatPixelCode -%}
    	{%assign pixelCode = field | last %}
    	<p>{{pixelCode}}</p>
    {%- endfor -%}
  </div>
  <meta name="shopCurrency" content="{{shop.currency}}" />
  {% if shop.customer_accounts_enabled and customer %}
      <meta name="customerEmail" content="{{customer.email}}" />
  {%endif%}
	<script src="'.$permanent_domain.'" defer="defer"></script>
{%endif%}';
				
			$snippet_fields = array( "asset" => array('key' => 'snippets/snapTrack.liquid', 'value' => $snippet_code));
			$json_snippet = json_encode($snippet_fields);
			$curl = curl_init(); 
			curl_setopt_array($curl, array(
				CURLOPT_URL => "https://$shop/admin/api/2022-10/themes/$themeId/assets.json",
				CURLOPT_RETURNTRANSFER => true,
				CURLOPT_CUSTOMREQUEST => "PUT",
				CURLOPT_POSTFIELDS => $json_snippet,
				CURLOPT_HTTPHEADER => array(
				"cache-control: no-cache",
				"content-type: application/json",
				"x-shopify-access-token: $access_token"
				),
			));
			$response = curl_exec($curl);
			$err = curl_error($curl);
			curl_close($curl);
			if ($err) {
				//echo "cURL Error #:" . $err;
				echo 'Try again Later!';
			} else {
				echo $response;
			}
			
			
			// GET and Edit Theme.liquid
			$themeFile = $shopify("GET /admin/api/2022-10/themes/$themeId/assets.json?asset[key]=layout/theme.liquid&theme_id=$themeId");
			
			if (strpos($themeFile['value'], "{%include 'snapTrack' %}") === false || strpos($themeFile['value'], "<!-- hnk portfolio proof -->") === false) {
				$newHtml = $themeFile['value'];
				if (strpos($themeFile['value'], "{%include 'snapTrack' %}") === false) {
					$replacedCode = "{%include 'snapTrack' %}</head>";
					$newHtml = str_replace("</head>",$replacedCode,$newHtml);
				}
				if (strpos($themeFile['value'], "<!-- hnk portfolio proof -->") === false) {
					$replacedCode1 = "<head><!-- hnk portfolio proof -->";
					$newHtml = str_replace("<head>",$replacedCode1,$newHtml);
				}
				
				$themeFields = array( "asset" => array('key' => 'layout/theme.liquid', 'value' => $newHtml));
				$jsonTheme = json_encode($themeFields);
				
				$curl = curl_init(); 
				curl_setopt_array($curl, array(
					CURLOPT_URL => "https://$shop/admin/api/2022-10/themes/$themeId/assets.json",
					CURLOPT_RETURNTRANSFER => true,
					CURLOPT_CUSTOMREQUEST => "PUT",
					CURLOPT_POSTFIELDS => $jsonTheme,
					CURLOPT_HTTPHEADER => array(
					"cache-control: no-cache",
					"content-type: application/json",
					"x-shopify-access-token: $access_token"
					),
				));
				$response = curl_exec($curl);
				$err = curl_error($curl);
				curl_close($curl);
				if ($err) {
					//echo "cURL Error #:" . $err;
					echo 'Try again Later!';
				} else {
					echo $response;
				}
			}
			// end Code
		}
	}
}
catch (shopify\ApiException $e)
{
	# HTTP status code was >= 400 or response contained the key 'errors'
	echo $e;
	print_r($e->getRequest());
	print_r($e->getResponse());
}
?>